Bug 409361 - Review Request: dkim-milter - DomainKeys Identified Mail sender authentication sendmail milter
Review Request: dkim-milter - DomainKeys Identified Mail sender authenticatio...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-03 15:52 EST by Jim Radford
Modified: 2009-09-11 16:14 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-04-01 01:18:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mtasaka: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jim Radford 2007-12-03 15:52:53 EST
Spec URL: http://blackbean.org/review/dkim-milter.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.4.0-1.fc8.src.rpm
Description:
The dkim-milter package is an open source implementation of the DKIM
sender authentication system proposed by the E-mail Signing Technology
Group (ESTG), now a proposed standard of the IETF (RFC4871).

DKIM is an amalgamation of the DomainKeys (DK) proposal by Yahoo!, Inc.
and the Internet Identified Mail (IIM) proposal by Cisco.

This package consists of a library that implements the DKIM service and a
milter-based filter application that can plug in to the sendmail MTA to
provide that service to sufficiently recent sendmail MTAs and other MTAs
that support the milter protocol.
Comment 1 Mamoru TASAKA 2007-12-16 08:19:57 EST
I could not find your email address in cvsextras group.
Do you have to get sponsored? (please check
http://fedoraproject.org/wiki/PackageMaintainers/HowToGetSponsored )

By the way, I just tried to rebuild your package but
it failed.
http://koji.fedoraproject.org/koji/taskinfo?taskID=295723
Comment 2 Jim Radford 2007-12-17 20:56:35 EST
(In reply to comment #1)
> I could not find your email address in cvsextras group.
> Do you have to get sponsored? (please check
> http://fedoraproject.org/wiki/PackageMaintainers/HowToGetSponsored )

Yes, I'll need sponsorship (and an account) before I can check this in.

> By the way, I just tried to rebuild your package but it failed.
> http://koji.fedoraproject.org/koji/taskinfo?taskID=295723

Thanks.  I fixed the problem (missing build deps) and re-uploaded.
Comment 3 Mamoru TASAKA 2007-12-19 09:20:26 EST
Well, where is your new spec/srpm? (when you modify your spec/srpm,
please change the release number to avoid confusion)
Comment 4 Mamoru TASAKA 2007-12-31 03:52:52 EST
ping?
Comment 5 R P Herrold 2007-12-31 11:34:27 EST
Mamoru -- 

it seems it was overlaid without a update of Release number ... just from
appearances of matters.

As I look at the result, I see package component:

/usr/share/man/man3/ar.3.gz

which appears to be an: 
asynchronous resolver library  man page

which is poorly named as to a namespace communality (not a package conflict, of
course presently) with:

[dkim-milter]$ man -k ar | grep '^ar '
ar                   (1)  - create, modify, and extract from archives
ar                   (1p)  - create and maintain library archives
[dkim-milter]$

Just a thought that perhaps calling it 'libar' and seeking a change upstream to
avoid this very common collision, make sense.

My $0.02
Comment 6 Jim Radford 2007-12-31 13:06:15 EST
(In reply to comment #5)
> it seems it was overlaid without a update of Release number ... just from
> appearances of matters.

Yes.  I had assumed by his parenthetical comment that he knew I had uploaded on
top of the previous version.

> /usr/share/man/man3/ar.3.gz
 
I don't have a problem with this man page in theory since there isn't another
"ar" library.  Still it's pointless to include it unless libar.so and ar.h are
included as well (which they are not).  I'll just remove it.

Spec URL: http://blackbean.org/review/dkim-milter-3.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.4.0-3.fc8.src.rpm
Comment 7 Mamoru TASAKA 2008-01-15 12:46:33 EST
Once setting FE-Legal.

The license of sendmail doesn't seem to be listed on Fedora's license
list. If it is okay, would you add sendmail license to Fedora's license
list, spot?
Comment 8 Tom "spot" Callaway 2008-01-15 13:33:44 EST
The sendmail license is pending review from the FSF. Accordingly, this package
will have to hold as well. I'll see if I can get it bumped to the top of the queue.
Comment 9 Tom "spot" Callaway 2008-03-23 10:33:52 EDT
The Sendmail license is Free, and GPL compatible if Eric Allman, Sendmail Inc,
or the University of California are the copyright holder.

Lifting FE-Legal, use License: Sendmail
Comment 10 Mamoru TASAKA 2008-03-24 03:06:24 EDT
Thanks, spot.

Jim, as the newest dkim-milter seems 2.5.1, would you update
your srpm?
Comment 11 Jim Radford 2008-03-24 03:30:16 EDT
(In reply to comment #10)
> Jim, as the newest dkim-milter seems 2.5.1, would you update
> your srpm?

Spec URL: http://blackbean.org/review/dkim-milter-2.5.1-1.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.5.1-1.fc8.src.rpm
Comment 12 Mamoru TASAKA 2008-03-27 13:14:31 EDT
For 2.5.1-1:

* SourceURL
  - For Sourceforge source, please refer to
    http://fedoraproject.org/wiki/Packaging/SourceURL

* Scriptlets to add groups/users
  - has changed. Please refer to
    http://fedoraproject.org/wiki/Packaging/UsersAndGroups

* Compilation flags
  - Fedora specific compilation flags are not correctly
    honored. When gcc/g++ and so on are used, %optflags
    must be used as compilation flags (you can check
    what %optflags actually is by
    $ rpm --eval %optflags : check the section 
    "Compiler flags" of
    http://fedoraproject.org/wiki/Packaging/Guidelines )

* Timestamps
  - When using "cp" or "install" commands, add "-p" option
    to keep timestamps on installed files.
Comment 13 Jim Radford 2008-03-27 15:19:35 EDT
Thanks for the review.  I made the changes that you suggested plus I moved the
key directory from /var/db/dkim-milter to /etc/mail/dkim-milter/keys (since it's
never written to by the program).

Spec URL: http://blackbean.org/review/dkim-milter-2.5.1-2.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.5.1-2.fc8.src.rpm
Comment 14 Jim Radford 2008-03-27 19:11:45 EDT
Updated to handle a change in the way the socket is specified.

Spec URL: http://blackbean.org/review/dkim-milter-2.5.1-3.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.5.1-3.fc8.src.rpm
Comment 15 Mamoru TASAKA 2008-03-29 14:22:48 EDT
Actually I am already sponsoring Jim :)
Comment 16 Mamoru TASAKA 2008-03-29 14:37:22 EDT
Well, it may be that you are not seeing the issue below,
however on rawhide:

-------------------------------------------------------------------------
[root@localhost ~]# LANG=C service dkim-milter start
Starting DomainKeys Identified Mail Milter (dkim-filter): -bash: dkim-filter:
command not found
                                                           [FAILED]
-------------------------------------------------------------------------

When I add "set -x" to /etc/rc.d/init.d/functions, this actually
fails like below:
-------------------------------------------------------------------------
+ runuser -s /bin/bash - dkim-milter -c 'ulimit -S -c 0 >/dev/null 2>&1 ;
dkim-filter -x /etc/mail/dkim-milter/dkim-filter.conf -P
/var/run/dkim-milter.pid -p local:/var/run/dkim-milter/dkim-milter.sock'
-bash: dkim-filter: command not found
+ '[' 127 -eq 0 ']'
+ failure 'dkim-filter startup'
-------------------------------------------------------------------------

Here when runuser is executed as dkim-milter user, it uses "login shell"
(runuser -s /bin/bash "-" ) then the PATH changes as:
-------------------------------------------------------------------------
[root@localhost ~]# runuser -s /bin/bash - dkim-milter -c 'echo $PATH'
/usr/lib/qt-3.3/bin:/usr/kerberos/bin:/usr/local/bin:/bin:/usr/bin:/usr/X11R6/bin
[root@localhost ~]# runuser -s /bin/bash dkim-milter -c 'echo $PATH'
/usr/lib/qt-3.3/bin:/usr/kerberos/sbin:/usr/kerberos/bin:/usr//sbin:/usr//bin:/sbin:/bin:/usr/sbin:/usr/bin:/usr/X11R6/bin:/root/bin
-------------------------------------------------------------------------
Then the shell cannot find /usr/bin/dkim-filter and 
"service dkim-filter start" fails (please check the lines around
250 of /etc/rc.d/init.d/functions ).

Comment 17 Mamoru TASAKA 2008-03-29 15:03:03 EDT
(In reply to comment #16)
> Then the shell cannot find /usr/bin/dkim-filter and 
> "service dkim-filter start" fails (please check the lines around
> 250 of /etc/rc.d/init.d/functions ).

Should be read as service dkim-milter start fails .... 

Comment 18 Jim Radford 2008-03-29 17:28:52 EDT
Added /sbin and /usr/sbin to the PATH if the init script.

Spec URL: http://blackbean.org/review/dkim-milter-2.5.1-4.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.5.1-4.fc8.src.rpm

PS, do you think this package would be accepted into Fedora?

  Spec URL: http://blackbean.org/review/sbin-1.0-2.spec
Comment 19 Mamoru TASAKA 2008-03-29 21:45:47 EDT
First reply to P.S.

(In reply to comment #18)
> PS, do you think this package would be accepted into Fedora?
> 
>   Spec URL: http://blackbean.org/review/sbin-1.0-2.spec

While I don't think it would be accepted,
I guess you want to participate in the following thread
(currently I don't follow the thread as it is already very long...)
https://www.redhat.com/archives/fedora-devel-list/2008-March/msg02555.html
Comment 20 Mamoru TASAKA 2008-03-30 12:53:57 EDT
Well...
--------------------------------------------------------------------
[root@localhost ~]# rpm -q dkim-milter
dkim-milter-2.5.1-4.fc9.i386
[root@localhost ~]# LANG=C service dkim-milter start
Starting DomainKeys Identified Mail Milter (dkim-filter): -bash: dkim-filter:
command not found
                                                           [FAILED]
---------------------------------------------------------------------

As said in comment 16:
- First /etc/rc.d/init.d/dkim-milter is called, this script
  "source"s /etc/rc.d/init.d/functions, so at this stage
  the shell executing /etc/rc.d/init.d/dkim-milter has
  /usr/sbin in its PATH.

- Then /etc/rc.d/init.d tries
  * to call another "login shell" (login shell does _not inherit_ 
    PATH environ)
    _not inherited_ )
  * and the called (another) shell tries to find dkim-filter

So this fails as before.
Then:
- The easiest fix is to define another local variable such as
   prog_with_full_path as /usr/bin/$prog and replace
   the line "daemon --user ${user} ${prog} -x ....." with it.
- Or to use your "sbin.spec" idea only for dkim-milter user/group,
  i.e. install a shell script into /etc/profile.d to add /sbin and
  /usr/sbin in PATH if the user/group is dkim-milter
Comment 21 Mamoru TASAKA 2008-03-30 12:55:28 EDT
One more note:
- It is not "must" item, however would you explain why you don't execute
  restart option as %postun? (please check the section
  "Services" of
  http://fedoraproject.org/wiki/Packaging/ScriptletSnippets
Comment 22 Jim Radford 2008-03-30 15:16:59 EDT
(In reply to comment #21)
> would you explain why you don't execute restart option as %postun?

That was just an oversight on my part.  I added that.

(In reply to comment #20)
> As said in comment 16:
>   * to call another "login shell" (login shell does _not inherit_ 

Yes, I saw that the first time, but I had forgotten by the time I comparing the
two solutions. :)  I switched to the full path technique.

Spec URL: http://blackbean.org/review/dkim-milter-2.5.1-5.spec
SRPM URL: http://blackbean.org/review/dkim-milter-2.5.1-5.fc8.src.rpm
Comment 23 Mamoru TASAKA 2008-03-31 12:10:36 EDT
Okay.

------------------------------------------------------------------
     This package (dkim-milter) is APPROVED by me
------------------------------------------------------------------
Comment 24 Jim Radford 2008-03-31 12:58:49 EDT
New Package CVS Request
=======================
Package Name: dkim-milter
Short Description: DomainKeys Identified Mail sender authentication sendmail milter
Owners: radford
Branches: F-8
InitialCC: 
Cvsextras Commits: yes
Comment 25 Kevin Fenzi 2008-03-31 23:13:37 EDT
cvs done.
Comment 26 Jim Radford 2008-04-01 00:04:47 EDT
Package Change Request
======================
Package Name: dkim-milter
New Branches: dist-f9, F-8

Looks like I just missed the dist-f9 boat by a few hours.  Any chance I can hop on?
Comment 27 Kevin Fenzi 2008-04-01 00:09:36 EDT
dist-f9 boat? 

The 'devel' branch is currently what will become f9. 
All packages will be mass branched at some point before f9, and you will get a
new F-9 branch thats a copy of devel at that point in time. Then, devel will be
what will become F-10. You don't need to do anything for this. 

You can request an early F-9 branch if you know that you have disruptive changes
you don't want to get into F-9 that you would like to check in now, but that
seems odd for a new package. 

Does that make sense? 
Comment 28 Jim Radford 2008-04-01 00:20:55 EDT
Yes, that is exactly how I expected things to happen until I got this error.

[devel] $ make build
/usr/bin/koji  build  dist-f9
'cvs://cvs.fedoraproject.org/cvs/pkgs?rpms/dkim-milter/devel#dkim-milter-2_5_1-5_fc9'
[...]
541238 build (dist-f9, devel:dkim-milter-2_5_1-5_fc9): open
(xenbuilder2.fedora.redhat.com) -> FAILED: BuildError: package dkim-milter not
in list for tag dist-f9

Maybe something just hasn't propagated to the right place yet?
Comment 29 Jim Radford 2008-04-01 01:18:45 EDT
Looks like that was the case because it seemed to work after waiting a few hours
and retrying.
Comment 30 Kevin Fenzi 2008-04-01 11:35:57 EDT
Yeah, the sync script runs at the top of the hour, so you should only have to
wait until the top of the following hour from when cvs was processed. 
Comment 31 Jim Radford 2009-09-11 12:05:44 EDT
Package Change Request
======================
Package Name: dkim-milter
New Branches: EL-5
Owners: radford
Comment 32 Jason Tibbitts 2009-09-11 16:14:14 EDT
CVS done.

Note You need to log in before you can comment on or make changes to this bug.